/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#include "qubopt.h"
using namespace std;

PyMethodDef optModule_methods[] = {
  // module-scope functions
  {"AMP", amptreePyiface, METH_VARARGS,
   "Estimate Amplitudes with Baum-Welch : AMP(cfgTree, [idlTree1, idlTree2, ...])"},
  {"MIL", miltreePyiface, METH_VARARGS,
   "Optimize rates using idealization : MIL(cfgTree, [idlTree1, idlTree2, ...])"},
  {"MPL", mpltreePyiface, METH_VARARGS,
   "Optimize rates using raw data : MPL(cfgTree, [idlTree1, idlTree2, ...])"},
  {"MSearch", msearch_tree_Pyiface, METH_VARARGS,
   "MIL all model topologies : MSearch(cfgTree, [idlTree1, idlTree2, ...], modelNums)"},
  {"SKM", skmtreePyiface, METH_VARARGS,
   "Idealize data : SKM(cfgTree, [idlTree1, idlTree2, ...])"},
  {"Stat", stattreePyiface, METH_VARARGS,
   "Data/Idl statistics : Stat(cfgTree, [DataSet, DataSet, ...])"},
  {"MergeModels", DoMergeModelsPy, METH_VARARGS,
   "..."},
  {"UnmergeModels", DoUnmergeModelsPy, METH_VARARGS,
   "..."},
  {"BalanceAllLoops", DoBalanceAllLoopsPy, METH_VARARGS,
  "..."},
  {"PareConstraints", DoPareConstraintsPy, METH_VARARGS,
  "..."},
  {"CheckLoopStimuli", DoCheckLoopStimuliPy, METH_VARARGS,
  "..."},
  {NULL, NULL, 0, NULL}
};

extern "C" MIL_API int __stdcall qubopt_pyinit()
{
  Py_InitModule("qubopt", optModule_methods);
  return 0;
}
